/************************************************************************
**	Project:	HW 4; An Nbody Type Program			*
**									*
**									*
**	Submited By:	Marjorie V Quant				*
**	Date:		29 Mar 00					*
************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

#define TAG 0

int low = 1;
int high = 7;

int randval(int lowvalue, int highvalue);

void main (int argc, char* argv[])
{

  int p, rank;
  int i, j, k, l;
  int n, N;
  int x[1000], y[1000], y_recv[1000];
  int g[10];
  int function, sum_x, total_sum;
  int next_proc, prev_proc;

  MPI_Status status; 

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);/*rank number of the processes */
  MPI_Comm_size(MPI_COMM_WORLD, &p);	/*number of processors called*/

  N = 400;
  n = N/p;

  function = 0;
  total_sum = 0;
  sum_x = 0;

  if(rank == p-1)
   next_proc = 0;
  else
   next_proc = rank + 1;

  if(rank == 0)
   prev_proc = p - 1;
  else
   prev_proc = rank - 1;

  /* populate the array */
  for(i = 0; i < n; i++) {
   x[i] = randval(low, high);
   y[i] = randval(low, high);
   y_recv[i] = randval(low, high);
  }

  for(k = 0; k < p-1; k++)
  {
   if ((rank%2) ==0)
   {
     for(i = 0; i < n; i++)
     {
      for(j = 0; j < n; j++)
      {
        function = (x[i]*x[i]) + (y_recv[j]*y_recv[j]);
        sum_x += function;
      }
     }
     for (i=0; i<n; i++)
     {
       y[i] = y_recv[i];
     }
    
     MPI_Ssend(y, n, MPI_INT, next_proc, TAG, MPI_COMM_WORLD);
     MPI_Recv(y_recv, n, MPI_INT, prev_proc, TAG, MPI_COMM_WORLD, &status);
    }

     else
     {
       for(i = 0; i < n; i++)
       {
        for(j = 0; j < n; j++)
        {
          function = (x[i]*x[i]) + (y_recv[j]*y_recv[j]);
          sum_x += function;
        }
       }
       for (i=0; i<n; i++)
       {
         y[i] = y_recv[i];
       }
          
       MPI_Recv(y_recv, n, MPI_INT, prev_proc, TAG, MPI_COMM_WORLD, &status);
       MPI_Ssend(y, n, MPI_INT, next_proc, TAG, MPI_COMM_WORLD);
      }

    }  /*end of for k */

   MPI_Gather(&sum_x, 1, MPI_INT, g, 1, MPI_INT, TAG, MPI_COMM_WORLD);
   if (rank ==0)
   {
     for (i=0; i<p; i++)
     {
       total_sum += g[i];
     }
   printf("The total sum of f(a,b) is %d\n", total_sum);
   }

   

  MPI_Finalize();
}	/*end of main */    


int randval(int lowvalue, int highvalue)
{
  int val;
  
  val = (int)(((rand()%1000)/1000)*(highvalue - lowvalue) +lowvalue);
  return(val);
}

























